//	2000/07/22 Ogasawara Hiroyuki

#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>

#include	"_dirent.h"

extern void	__dirent_fill( DIR *dirbuf );

DIR*
opendir( const char *path )
{
	DIR	*dirp= (DIR*)malloc( sizeof(DIR) );
	int	fd;
	if( dirp ){
		dirp->workbuf= NULL;
		if( (fd= open( path, O_RDONLY )) >= 0 ){
			struct stat	dirstat;
			dirp->fd= fd;
			dirp->index= 0;
			fstat( fd, &dirstat );
			dirp->dirsize= dirstat.st_size;
			if( dirp->dirsize < 1024*4 ){
				dirp->dirsize= 1024*4;
			}
			if( dirp->workbuf= (void*)malloc( dirp->dirsize ) ){
				__dirent_fill( dirp );
				return	dirp;
			}
			close( fd );
		}
		free( dirp );
	}
	return	NULL;
}

int
closedir( DIR *dirp )
{
	if( dirp ){
		if( dirp->workbuf ){
			free( dirp->workbuf );
			dirp->workbuf= NULL;
		}
		close( dirp->fd );
		free( dirp );
	}
	return	0;	// success
}



